#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.do { setenv(SL_TABLE_RO_PATH /usr/local/lib/nsl/scripts/docstrip:./) }
main
{
	prefix 'base:'
	global first_in_block;
	global ctl_line;
	global line_buffer;
	global escape_buffer;
	global escape_ctl;
	global para = '.P';
	global needs_para;
	global request_para;
	global stream_stack = instream();
	global saved_state;
	global bracket_cnt = 0;
	global LINE;
	global cur_header;
	global define_name;
	global index_entry;
	global counter = 0;
	global def_open def_close def_term def_ts def_buffer def_spacing def_level;
	write ".TH get(ARGV 1) 1 \"PROTECT(safe-get(ARGV 2))\" \"PROTECT(safe-get(ARGV 3))\" \"PROTECT(safe-get(ARGV 4))\"\n";
	table docstrip_spec +docstrip_spec;
	table docstrip_refs !docstrip_refs;
	table docstrip_defs '';
	table docstrip_todo !docstrip_todo;
	onerror handler;
	echo 'Generating documentation \r'
}

eof
{
	if eq(1 depth(stream_stack)) echo '' exit endif
	if neq(int 0 $counter) echo "end of include" endif
	rmstream $stream_stack
	instream pop(stream_stack);
	prefix($saved_state)
	pop counter
	pop saved_state
}

handler
{
	onerror ""
	echo "$1\nprefix = prefix()\nline_buffer = $line_buffer\nescape_ctl = $escape_ctl\n"
	echo "first_in_block = $first_in_block\n"
	echo "ivalue = tag(ivalue)"
	exit
}

char "base:[/#]" { prefix 'comment1:'  set first_in_block = true;  
				set request_para = ''; 
			  }
char "comment1:[/#*]" { prefix 'comment2:' }
char "comment1:?" { 
			prefix 'base:' 
			}
char "comment2:[/#*]" { prefix 'docstrip-init:' }
char "comment2:?" { 
			prefix 'base:' 
			}
char "docstrip-init:\n" { prefix 'docstrip:' dispatch }
char "docstrip-init:[[:space:]/#*]" { return }
char "docstrip-init:?" { prefix 'docstrip:' dispatch }
char "docstrip:\n" { 
		echo '['incr(counter 1)'] \r'
		if $escape_ctl error 'unfinished argument'; endif
		if $line_buffer
			if $first_in_block
				set cur_header = $LINE
				set escape_ctl = '.SS \\"\$LINE\\"\\n';
				flush_escape()
				set para = '.IP';
				set first_in_block = ""
			else
				if $request_para
					write "$para\n"
					set request_para = ''
				endif
			endif
			write trim($line_buffer)'\n'
			set line_buffer = ''
		else 
			if and(not($first_in_block) not($ctl_line))
				write "$para\n";
			endif
		endif
		if $needs_para
			set request_para = true
			set needs_para = ''
		endif
		set ctl_line = ''
		prefix 'comment1:'
}

char "docstrip:\\\\"
{
	prefix "escape:"
	set escape_buffer = "";
}

char "docstrip:[[:space:]]"
{
	if or($escape_ctl and($line_buffer neq(substr($line_buffer sub(length($line_buffer) 1) 1) '\n')))
		set line_buffer = $(line_buffer)$[value];
	endif
}

char "docstrip:?" { 
	if and(eq($[value] ']') $escape_ctl)
		flush_escape()
	else
		set line_buffer = $(line_buffer)PROTECT($[value])
	endif
}

char "verbatim:\\[" 
{
	incr bracket_cnt 1;
	set line_buffer = $(line_buffer)$[value]
}

char "verbatim:\\]"
{
	if eq($bracket_cnt 0) 
		flush_escape()
	else
		decr bracket_cnt 1;
		set line_buffer = $(line_buffer)$[value]
	endif
}

char "verbatim:?" { set line_buffer = $(line_buffer)$[value] }

flush_escape
{
	prefix 'docstrip:'
	set LINE = $line_buffer;
	pop line_buffer;
	set line_buffer = $(line_buffer)eval($escape_ctl);
	pop escape_ctl;
}

process_escape
{
	def verbatim;
	def has_arg;
	if check(docstrip_spec '\\'$escape_buffer'[v') 
		set verbatim = true
		set has_arg = true
	else
		if check(docstrip_spec '\\'$escape_buffer'[') 
			set has_arg = true
		endif
	endif
	if $has_arg
		if neq($[value] '[') error 'argument missing' endif
		push(escape_ctl = get(docstrip_spec '\\'$escape_buffer'['cond($verbatim 'v')))
		push(line_buffer = '')
		set ctl_line = true
	else
		if check(docstrip_spec '\\'$escape_buffer)
			set line_buffer = $(line_buffer)eval(get(docstrip_spec '\\'$escape_buffer))
			set ctl_line = true
		else
			set line_buffer = $(line_buffer)$(escape_buffer)
		endif
	endif
	set escape_buffer = ''
	if isprefix(prefix() 'escape') prefix cond($verbatim 'verbatim:' 'docstrip:') endif
}

char "escape:[[:alpha:]]" { set escape_buffer = $[value]  prefix 'escape1:' }
char "escape:?"
{
	set escape_buffer = $[value];
	process_escape()
}

char "escape1:[[:alnum:]]" { set escape_buffer = $escape_buffer$[value]; }
char "escape1:[[]"
{
	process_escape()
}

char "escape1:?"
{
	process_escape()
	dispatch()
}

EAT { return } # used within docstrip_spec macros to discard the return value 

NL {
	if and($line_buffer neq(substr($line_buffer sub(length($line_buffer) 1) 1) '\n'))
		return('\n')
	endif	
}

PARA
{
	set request_para = ''
	return(cond($1 $1 $para))
}

ENDPARA { set needs_para = true }

SETPARA { push(para = $1); }

RSTPARA { pop para; if not($para) set para = '.P' endif }

NOHEADER { set first_in_block = '' }

PROTECT
{
	def res = substit($1 '\\' '\\(rs');
	set res = substit($res '"' '\\(dq');
	set res = substit($res '\'' '\\(cq');
	set res = substit($res '.' '\\.');
	return($res)
}

NEXTARG { set escape_buffer = $1; prefix 'escape1:'; }

REF { 
		def item = trim($1);
		if not(check(docstrip_refs $item))
			insert docstrip_refs $item '';
		endif
}

TODO { 
		def item = trim($1);
		if not(check(docstrip_todo $item))
			insert docstrip_todo $item '';
		endif
}

UNDOCUMENTED
{
	TODO("document \'$cur_header\'")
	clear cur_header
	return(PROTECT('\nTo be documented'))
}

SEEALSO
{
	def iter;
	def res;
	if neq(int count(docstrip_refs) 0)
		foreach iter docstrip_refs
			if $res set res =  $res" \",\"\n"; endif
			set res = $res".IR \"$iter\"";
		loop
		return("\n.SH \"SEE ALSO\"\n$res")
	endif
}

SETDEFNAME
{
	set define_name = $1
}

DEFINE
{
	insert docstrip_defs $define_name $1
}

USE
{
	def s = defstream(* "inline://get(docstrip_defs $1)" basic);
	push(stream_stack = $s)
	instream $s
	push(saved_state = prefix())
	echo "\nmacro included"
	push(counter = 0)
}

INCLUDE
{
	def s = defstream(* $1 basic);
	push(stream_stack = $s)
	instream $s
	push(saved_state = prefix('base:'))
	echo "\nincluded $1"
	push(counter = 0)
}

DEFINITION(opening closing ending end_subst spacing)
{
	set def_open = $opening;
	set def_close = $closing;
	set def_term = $ending;
	set def_ts = $end_subst;
	set def_spacing = $spacing;
	set def_level = 0;
	set def_buffer = '';
	prefix 'def-init:'
}

char "def-init:[[:space:]]" {}
char "def-init:?" { prefix 'def-main:' dispatch }
char "def-main:\n" 
{  
}

char "def-main:?"
{
}

safe-get
{
	if check($1 $2)
		return(get($1 $2))
	endif
}
