#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.module <files>
.module <time>

dirname(fname)
{
	def idx = rindex($fname /);
	if $idx
		return(substr($fname 0 add(1 $idx)))
	endif
}

basename(fname suffix='' sep='/')
{
	def idx = rindex($fname $sep);
	set idx = cond($idx add($idx 1) 0)
	set fname = substr($fname $idx)
	if issuffix($fname $suffix)
		set fname = substr($fname 0 sub(length($fname) length($suffix)))
	endif
	return($fname)
}

dosbasename(fname suffix='')
{
	set fname = basename($fname $suffix '\\')
	if index($fname ':')
		set fname = split($fname ':' '' '')
	endif
	return($fname)
}

dotlock(fname)
{
	def dir = dirname($fname);
	def tmp = tmpfile($(dir)\.pid());
	def strm = defstream(* $tmp basic true);
	writeto $strm pid();
	release stream $strm
	link $tmp $fname\.lock
	if ioerror() clearerr() rmfile($tmp) return endif
	rmfile($tmp)
	return(true)
}

dotlock-wait(fname delay=10 retry=10000)
{
	while(not(dotlock($fname)))
		sleep $delay
		decr retry 1
		if eq(int 0 $retry) return endif
	loop
	return(true)
}
