#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.do { global optind ignore_this; }

get_option(opt)
{
	def tmp;
	if check(src_opts $opt)
		set tmp = get(src_opts $opt)
		if eq(substr($tmp 0 1) =)
			return(get_option(substr($tmp 1)))
		else
			if eq(substr($tmp 0 1) :)
				return(cond(substr($tmp 1) $tmp :$opt))
			else
				return(cond($tmp $tmp $opt))
			endif
		endif
	else
		return('')
	endif
}

process_short_option(opts extra)
{
	def r = '';
	while $opts
		set r = get_option(substr($opts 0 1))
		if not($r)
			callback(unknown substr($opts 0 1) '' $extra)
		elsif eq(substr($r 0 1) :)
			if substr($opts 1)
				callback(option substr($r 1) substr($opts 1) $extra)
				break
			else
				callback(option substr($r 1) get(ARGV add($optind 1)) $extra)
				set ignore_this = true
			endif
		else
			callback(option $r '' $extra)
		endif
		set opts = substr($opts 1)
	loop
}

process_long_option(opt extra)
{
	def arg = split($opt '=' '' opt);
	def r = get_option($opt);
	if not($r)
		callback(unknown $opt '' $extra)
	elsif eq(substr($r 0 1) :)
		if not($arg) error "missing argument for \'--$opt\'" endif
		callback(option substr($r 1) $arg $extra)
	else
		if $arg error "argument not allowed for \'--$opt\'" endif
		callback(option $r '' $extra)
	endif
}

getopt(src_opts callback extra='')
{
	import storage src_opts $src_opts
	import storage optable $src_opts
	import proc callback $callback
	def i argv arg opt only_names opt1;
	set ignore_this = true
	def j;
	foreach optind ARGV
		if $ignore_this set ignore_this = '' continue endif
		set argv = get(ARGV $optind)
		if $only_names
			callback(name $argv '' $extra)
			continue
		endif
		if eq($argv --)
			set only_names = true
		elsif eq(substr($argv 0 2) --)
			process_long_option(substr($argv 2) $extra)
		elsif and(eq(substr($argv 0 1) -) substr($argv 1))
			process_short_option(substr($argv 1) $extra)
		else
			callback(name $argv '' $extra);
		endif
	loop
	release proc callback
	release storage src_opts
}
.do { export proc getopt sys:getopt }
