#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.module <files>
main
{
	defstream ins file://get(ARGV 1) html;
	defstream outs file://get(ARGV 2) html true;
	outstream outs
	ioctl ins keepspaces;
	instream ins
	global number = get(ARGV 3);
	global current-stream = ins parent-prefix dest-charset src-charset translation;
	defautoseq win2koi 'cp1251:Tounicode|koi8r:Tonative'
	defautoseq koi2win 'koi8r:Tounicode|cp1251:Tonative'
	defautoseq koi2utf8 'koi8r:Tounicode|utf8:Tonative'
	defautoseq win2utf8 'cp1251:Tounicode|utf8:Tonative'
	defautoseq utf82win 'utf8:Tounicode|cp1251:Tonative'
	defautoseq utf82koi 'utf8:Tounicode|koi8r:Tonative'
	global utf8-names = list(utf8 UTF8 utf-8 UTF-8)
		   koi-names = list(koi8 KOI8 koi8-r KOI8-R koi8r KOI8R)
		   win-names = list(cp1251 CP1251 windows-1251 WINDOWS-1251 Windows-1251
		   					cp-1251 CP-1251 windows1251 WINDOWS1251 Windows1251
		   				   )
}

tag "INCLUDE"
{
	if exists(substit(tag(FILE) % $number))
		push parent-prefix
		set parent-prefix = prefix()
		prefix 'nested:'
		push(current-stream = defstream(* file://substit(tag(FILE) % $number) html))
		instream($current-stream)
		ioctl instream() keepspaces
	endif
}

eof
{
	rmstream $current-stream
	pop current-stream
	if $current-stream
		instream($current-stream)
		prefix($parent-prefix)
		pop parent-prefix
	endif
}

tag "nested:INCLUDE"
{
	dispatch('')
}

tag "META"
{
	writetag;
	if eqi(tag(HTTP-EQUIV) content-type)
		set dest-charset = detect-charset()
	endif
}

tag "nested-header:META"
{
	writetag;
	if $dest-charset
		if eqi(tag(HTTP-EQUIV) content-type)
			set src-charset = detect-charset()
			push translation
			if $src-charset
				set translation = $src-charset\2$dest-charset
			endif
		endif
	endif
}

tag "nested-header:BODY"
{
	prefix 'nested:'
}

tag "nested-header:*" 
{ 
# swallow 
}

tag "nested:HTML"
{
	prefix 'nested-header:'
}

tag "nested:/BODY" 
{ 
	eof()
}

tag "nested:/HTML"
{
	eof()
}

tag "nested:DNL" { prefix 'nested-dnl:'}
tag "DNL" { prefix 'dnl:' }

tag "dnl:*" {}
tag "nested-dnl:*" {}
char "dnl:\n" { prefix '' }
char "nested-dnl:\n" { prefix 'nested:' }
char "dnl:?" {}
char "nested-dnl:?" {}

tag "*" { writetag }

char "nested-header:?" 
{ 
# swallow
}
char "nested:?" { write translate($translation $[value]) }
char "?" { writetag }

detect-charset()
{
	def pos = indexi(tag(CONTENT) charset=);
	def cs;
	if $pos
		split(substr(tag(CONTENT) add(length(charset=) $pos)) '; ' '' cs)
		if check($utf8-names $cs) return(utf8) endif
		if check($koi-names $cs) return(koi) endif
		if check($win-names $cs) return(win) endif
	endif
}
