#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

load-session(id)
{
	local(table("_session_$id" "+/tmp/.nsl-session-$id"));
	def iter type name pool sto;
	foreach iter "_session_$id"
		set name = split($iter ' ' '' type)
		if eq($type global)
			global $name = get("_session_$id" $iter);
		elsif eq($type shared)
			set name = split($name ' ' '' pool)
			pool $pool
			using $pool
			shared $name = get("_session_$id" $iter);
		elsif eq($type storage)
			split($name ' ' '' name)
			set type = get("_session_$id" $iter)
			if eq($type array)
				set sto = array($name)
			elsif eq($type table)
				set sto = table($name '')
			elsif eq($type list)
				set sto = list()
				rename storage $sto $name
			else
				error "Unsupported session storage"
			endif
		elsif eq($type within)
			set sto = split($name '\t' '' name)
			insert $name $sto get("_session_$id" $iter)
		else
			error "Broken session!"
		endif
	loop
}

update-session(id)
{
	local(table("_session_$id" "/tmp/.nsl-session-$id"))
	def iter type name pool iter1;
	foreach iter "_session_$id"
		set name = split($iter ' ' '' type)
		if eq($type global)
			if check(GLOBALS $name)
				put "_session_$id" $iter get(GLOBALS $name)
			endif
		elsif eq($type shared)
			set name = split($name ' ' '' pool)
			using $pool
			if check(SHAREDS $name)
				put "_session_$id" $iter get(SHAREDS $name)
			endif
		elsif eq($type within)
			set name = split($name '\t' '' pool)
			if not(check($pool $name))
				mark-remove("_session_$id" $iter)
			endif
		elsif eq($type storage)
			split($name ' ' '' name)
			foreach iter1 $name
				if check("_session_$id" "within $name\t$iter1")
					put "_session_$id" "within $name\t$iter1" get($name $iter1)
				else
					insert "_session_$id" "within $name\t$iter1" get($name $iter1)
				endif
			loop
		else
			error "Broken session!"
		endif
	loop
	do-remove("_session_$id")
}
