#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.pool default
main
{
	table identity get(ARGV 1)
	if not(check(identity lastlen))
		insert identity lastlen 0
	endif
	defstream instream get(ARGV 2) html;
	instream instream
	ioctl instream keepspaces;
	shared diversion;
	global basedir destination;
}

tag "BASE"
{
	if tag(DIR)
		set basedir = tag(DIR)
		if not(issuffix($basedir /))
			set basedir = $basedir/
		endif
	endif
}

tag "IDENTITY"
{
	if tag(ID)
		safe-insert(identity id tag(ID))
	endif
	if tag(PASSCODE)
		safe-insert(identity passcode tag(PASSCODE))
	endif
	if tag(EMAIL)
		safe-insert(identity email tag(EMAIL))
	endif
	if tag(MYEMAIL)
		safe-insert(identity myemail tag(MYEMAIL))
	endif
	if tag(MBOX)
		safe-insert(identity mbox $(basedir)tag(mbox))
	endif
}

tag "OTHER"
{
	safe-insert(identity tag(VAR) cond(tag(VALUE) tag(VALUE) $(basedir)tag(DIR)))
}

tag "MIME"
{
	safe-insert(identity tag(TYPE) $(basedir)tag(DIR))
}

tag "NEWS"
{
	if tag(DIR)
		safe-insert(identity news $(basedir)tag(DIR))
	endif
	if tag(HOT)
		safe-insert(identity hotnews $(basedir)tag(HOT))
	endif
	if tag(CHARSET)
		safe-insert(identity newscharset tag(CHARSET))
	endif
	if tag(EXT)
		safe-insert(identity newsext tag(EXT))
	endif
	if tag(MAX)
		safe-insert(identity newsmax tag(MAX))
	endif
	if tag(MIN)
		safe-insert(identity newsmin tag(MIN))
	endif
	if tag(MODE)
		safe-insert(identity newsmode tag(MODE))
	endif
	if tag(BLOCK)
		set destination = tag(BLOCK)
		prefix 'news:'
		clear diversion
		defstream diversion 'inline://default/diversion' html true;
	endif
}

tag "news:/NEWS"
{
	rmstream diversion
	safe-insert(identity news$destination $diversion)
	prefix ''
}

tag "news:*" { writetagto diversion }
char "news:?" { writetagto diversion }

tag "!--" { }

tag "*"
{
	echo "Unknown tag: $[]"
}

safe-insert(sto key val)
{
	if(check($sto $key))
		put $sto $key $val
	else
		insert $sto $key $val
	endif
}
