#! /usr/local/bin/sl
#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

main
{
#	setenv "SL_TABLE_PATH"  "./tables"
	global tname = get-fname(1 "Table:");
	table tbl !$tname
	global key;
	global val;
	if not(instream())
		def s = get-fname(2 "Input file:");
		if not($s) 
			fill-from-console()
			exit
		endif
		defstream mystream $s basic;
		instream mystream
	endif
	prefix("key:")
}

get-fname
{
	if check(ARGV $1) return(get(ARGV $1)) endif
	return(trim(readline($2)))
}

put-into-table
{
	if check(tbl $1)
		echo "Duplicate key \'$1\', ignored"
		return
	endif
	insert tbl $1 $2
}

fill-from-console
{
	def inbuf;
	def ifs = readline('Field separator:');
	if not($ifs) set ifs = ' ' endif
	while set(inbuf readline(?))
		set val = split($inbuf $ifs '' key);
		put-into-table($key $val)
	loop
}

char "key:\t" { prefix "value:" }

char "key:\n"
{
	if not($key) return endif
	put-into-table($key "")
	set key = ""
}

char "key:*" { set key = $(key)$[value] }

char "value:\n" { put-into-table($key $val); prefix "key:"  
					set key = ""
					set val = ""
				}

char "value:*" { set val = $(val)$[value] }

