#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.module <crypt>
.module <files>

.do { defautoseq _session_tohex unicode:Tohex16 }
init-session(name)
{
	def ssid = translate(_session_tohex substr(crypt(pid()id()$name '$1$nsl') 6));
	table "_session_$ssid" "!/tmp/.nsl-session-$ssid\.t";
	return($ssid);
}

session-var(id name pool='' ...)
{
	if not($pool)
		if check(GLOBALS $name)
			insert "_session_$id" "global $name" get(GLOBALS $name);
		else
			error "No such variable: $name"
		endif
		if arg(4)
			call(arg(4) $id get(GLOBALS $name) passargs(5))
		endif
	else
		using $pool
		if check(SHAREDS $name)
			insert "_session_$id" "shared using() $name" get(SHAREDS $name);
		else
			error "No such variable: $name in $pool"
		endif
		if arg(4)
			call(arg(4) $id get(GLOBALS $name) passargs(5))
		endif
	endif
}

session-storage(id name type ...)
{
	insert "_session_$id" "storage $name" $type;
	def iter;
	foreach iter $name
		insert "_session_$id" "within $name\t$iter" get($name $iter)
		if arg(4)
			call(arg(4) $id get($name $iter) passargs(5))
		endif
	loop
}

session-close(id)
{
	release storage "_session_$id"
}

delete-session(id)
{
	rmfile "/tmp/.nsl-session-$id\.t"
}
