#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#


.module <files>
.pool diversions
main
{
	table identity +get(ARGV 1)
	global allow_tags = list(A /A B /B BR EM /EM I /I IMG 
							P /P STRONG /STRONG UL OL /UL /OL LI /LI 
							H2 /H2 H3 /H3 SMALL /SMALL SUP /SUP SUB /SUB
							TABLE /TABLE TD TR /TD /TR
							&)
			nextfile emptyline = true newsmode tstamp;
	shared titleline titleline2 headline body;
	defstream header 'inline://diversions/headline' html true;
	defstream title 'inline://diversions/titleline' html true;
	defstream title2 'inline://diversions/titleline2' html true;
	defstream body 'inline://diversions/body' html true;
	set newsmode = cond(check(identity newsmode) eq(get(identity newsmode) separate))
	onerror error-handler
	if and(not($newsmode) not(check(identity nobody)))
		defstream destination "file://get(identity news).html" basic true;
	endif
	defstream hotdest "file://get(identity hotnews).html" basic true;
	def i nf = get(identity news) ne = get(identity newsext) nm = get(identity newsmax);
	global nmin = cond(check(identity newsmin) get(identity newsmin) 0);
	global nprev = cond(check(identity newsprev) get(identity newsprev))
		nnext = cond(check(identity newsnext) get(identity newsnext))
		nfirst = cond(check(identity newsfirst) get(identity newsfirst))
		nlast = cond(check(identity newslast) get(identity newslast));
	foreach i iota($nm)
		decr i 1
		set tstamp = ''
		if less(int $i $nmin) continue endif
		if exists($nf\.$i$ne)
			defstream source "file://$nf\.$i$ne" html;
			ioctl source keepspaces
			if $newsmode
				defstream destination "file://$nf\.$i\.html" basic true;
			endif
			set nextfile = ''
			set titleline = ''
			set titleline2 = ''
			set body = ''
			set headline = ''
			while;
				readfrom(source)
				if iseof() break endif
				dispatch
				if $nextfile break endif
			loop
			set titleline2 = make-substit(cond(check(identity newstitle2) get(identity newstitle2) get(identity newstitle)) $i $nm cond($titleline2 $titleline2 $titleline))
			set titleline = make-substit(get(identity newstitle) $i $nm $titleline)
			set headline = make-substit(get(identity newsheader) $i $nm $(titleline)cond(check(identity noheader) '' $headline))
			if not(check(identity nobody))
				set body = make-substit(get(identity newsbody) $i $nm $titleline2$body)
				writeto destination $body
			endif
			writeto hotdest $headline
			rmstream source
			if $newsmode
				rmstream destination
			endif
		endif
	loop
}

make-substit(pattern i maxi value)
{
	set pattern = substit($pattern %T $tstamp)
	set pattern = substit($pattern %% $i)
	set pattern = substit($pattern %- cond(eq(int $i $nmin) $nfirst substit($nprev %% sub($i 1))))
	set pattern = substit($pattern %+ cond(eq(int $i sub($maxi 1)) $nlast substit($nnext %% add($i 1))))
	set pattern = substit($pattern % $value first);
	return($pattern)
}

tag "HEAD"
{
	outstream header
}

tag "/HEAD"
{
	outstream body
}

tag "TITLE"
{
	if eq(outstream() body)
		outstream title2
	else
		outstream title
	endif
}


tag "/TITLE"
{
	if eq(outstream() title2)
		outstream body
	else
		outstream header
	endif
}

tag "BODY"
{
	outstream body
}

tag "/BODY"
{
	set nextfile = true	
}

tag "/ARTICLE"
{
	set nextfile = true
}

tag "TIMESTAMP"
{
	if tag(VALUE)
		set tstamp = tag(VALUE)
	else
		write $tstamp
	endif
}

tag "*"
{
	if check($allow_tags $[])
		writetag;
	endif
}

char "\n"
{
	if $emptyline writetag P; 
	endif
	writetag;
}

char "[[:space:]]"
{
	writetag;
}

char "?"
{
	set emptyline = ''
	writetag;
}


error-handler(msg fname lno)
{
	if check(identity email)
		defstream mailer "pipe:///usr/sbin/sendmail get(identity email)" basic true;
		writeto mailer "To: get(identity email)\n"
		writeto mailer "Subject: job processing failure (snml2html)\n"
		writeto mailer '\n'
		writeto mailer "$msg at $lno"\n
		rmstream mailer
	endif
	pass-error $msg
}
