#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.module <fpmath>
.module <files>
main
{
	table identity +get(ARGV 1)
	defstream out get(identity news).html basic true
	def nm = get(identity newsmax) i;
	fprecision 4
	foreach i sequence(\[0\-$nm\])
		if exists(get(identity news).$i\.t)
			process-file($i)
		endif
	loop
}

process-file(n)
{
	local table(tbl +get(identity news).$n\.t);
	def iter total = 0 output question qtitle ansno qno num;
	foreach iter tbl
		if not(isprefix($iter \#)) break endif
		if issuffix($iter .r) continue endif
		split($iter '.' '' qno ansno)
		if not($ansno)
			if $question
				set output = $(output)make-subst(newsitem $qtitle $question)
			endif
			set question = ''
			set qtitle = get(tbl $iter)
		else
			if eq(other $ansno)
				set num = count-answers(get(tbl $iter\.r))
			else
				set num = get(tbl $iter\.r)
			endif
			set num = cond(neq(int $num 0) $num\ (fdiv(mul(100 $num) get(tbl total))%\) 0)
			set question = $(question)substit(get(identity newssubitem) % get(tbl $iter):\ $num first)
		endif
	loop
	if $question
		set output = $(output)make-subst(newsitem $qtitle $question)
	endif
	set output = $(output)substit(get(identity newstotal) % get(tbl total))
	writeto out make-subst(newsbody get(tbl title) $output)
}

count-answers(text)
{
	def cnt = 0;
	if issuffix($text \f)
		set text = substr($text sub(length($text) 1))
	endif
	while $text
		set text = split($text '\f' '' '')
		incr cnt 1
	loop
	return($cnt)
}

make-subst(src title text)
{
	return(substit(substit(get(identity $src) %% $title) % $text))
}
