#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.module <readline>
.module <postgres>
main
{
	if not(sql(feature connect))
		error "SQL implementation is not full-functional"
	endif
	global dbname = trim(readline('Database:'));
	if not($dbname) exit endif
	sql connect "dbname = $dbname";
	if not(check-sql-error()) exit endif
	def quebuf;
	def que;
	def a;
	def b;
	def row;
	while set(quebuf get-query())
		set que = sql(query $quebuf)
		if check-sql-error()
			if neq(count($que) 0)
				set row = get($que 0)
				foreach a $row
					write "$a\t";
				loop
				write '\n';
				release storage $row
				foreach a $que
					set row = get($que $a);
					foreach b $row
						write "get($row $b)\t";
					loop
					write '\n';
					release storage $row
				loop
			endif
		endif
		release storage $que;
	loop
	sql disconnect;
}

check-sql-error
{
	if sql(error)
		echo "ERROR: sql(error)"
		sql clearerr;
		return('');
	else
		if sql(response)
			echo "RESPONSE: sql(response)"
			sql clearerr;
		endif
		return(true);
	endif
}

get-query
{
	def que;
	def tmp;
	def pref = '>';
	while;
		set tmp = readline($dbname$pref)
		if not($tmp) 
			if not($que) return; endif
			set pref = '>';
			set que = '';
			continue;
		endif
		set que = "$que\n$tmp"
		if eq(substr(trim($que) sub(length(trim($que)) 1) 1) ';')
			return($que);
		endif
		set pref = '>>'
	loop
}
